From 11b5f07ab408a75a72194b1f7a56a308575a3205 Mon Sep 17 00:00:00 2001
From: Markus Heidelberg <markus.heidelberg@web.de>
Date: Wed, 10 Dec 2014 00:02:21 +0100
Subject: [PATCH 10/28] Fix case sensitivity in include directives for building
 under Linux

---
 PowerEditor/src/MISC/Common/precompiledHeaders.h                      | 4 ++--
 PowerEditor/src/MISC/Process/Process.cpp                              | 2 +-
 PowerEditor/src/Notepad_plus.cpp                                      | 2 +-
 PowerEditor/src/NppIO.cpp                                             | 4 ++--
 PowerEditor/src/ScitillaComponent/ScintillaEditView.cpp               | 4 ++--
 PowerEditor/src/ScitillaComponent/UserDefineDialog.h                  | 2 +-
 PowerEditor/src/ScitillaComponent/UserDefineLangReference.h           | 2 +-
 PowerEditor/src/WinControls/AnsiCharPanel/ListView.h                  | 2 +-
 PowerEditor/src/WinControls/ColourPicker/WordStyleDlg.rc              | 2 +-
 PowerEditor/src/WinControls/DockingWnd/DockingManager.cpp             | 2 +-
 PowerEditor/src/WinControls/FindCharsInRange/FindCharsInRange.cpp     | 2 +-
 PowerEditor/src/WinControls/FunctionList/functionParser.cpp           | 4 ++--
 PowerEditor/src/WinControls/Grid/BabyGrid.cpp                         | 2 +-
 PowerEditor/src/WinControls/Grid/BabyGridWrapper.h                    | 2 +-
 PowerEditor/src/WinControls/ProjectPanel/TreeView.h                   | 2 +-
 PowerEditor/src/WinControls/ToolBar/ToolBar.cpp                       | 2 +-
 .../WinControls/VerticalFileSwitcher/VerticalFileSwitcherListView.h   | 2 +-
 17 files changed, 21 insertions(+), 21 deletions(-)

diff --git a/PowerEditor/src/MISC/Common/precompiledHeaders.h b/PowerEditor/src/MISC/Common/precompiledHeaders.h
index eba5513..9669a12 100644
--- a/PowerEditor/src/MISC/Common/precompiledHeaders.h
+++ b/PowerEditor/src/MISC/Common/precompiledHeaders.h
@@ -59,10 +59,10 @@
 // Windows Header Files
 #include <windows.h>
 #include <commctrl.h>
-#include <Shlobj.h>
+#include <shlobj.h>
 #include <shlwapi.h>
 #include <uxtheme.h>
-#include <Oleacc.h>
+#include <oleacc.h>
 #include <dbghelp.h>
 #include <eh.h>
 
diff --git a/PowerEditor/src/MISC/Process/Process.cpp b/PowerEditor/src/MISC/Process/Process.cpp
index 33c7818..13317e7 100644
--- a/PowerEditor/src/MISC/Process/Process.cpp
+++ b/PowerEditor/src/MISC/Process/Process.cpp
@@ -28,7 +28,7 @@
 
 #include "precompiledHeaders.h"
 #include "Parameters.h"
-#include "process.h"
+#include "Process.h"
 
 
 void Process::run()
diff --git a/PowerEditor/src/Notepad_plus.cpp b/PowerEditor/src/Notepad_plus.cpp
index f3c44d8..df10ac9 100644
--- a/PowerEditor/src/Notepad_plus.cpp
+++ b/PowerEditor/src/Notepad_plus.cpp
@@ -30,7 +30,7 @@
 #include "Notepad_plus.h"
 #include "Notepad_plus_Window.h"
 #include "FileDialog.h"
-#include "printer.h"
+#include "Printer.h"
 #include "FileNameStringSplitter.h"
 #include "lesDlgs.h"
 #include "Utf8_16.h"
diff --git a/PowerEditor/src/NppIO.cpp b/PowerEditor/src/NppIO.cpp
index 148155a..3121b6a 100644
--- a/PowerEditor/src/NppIO.cpp
+++ b/PowerEditor/src/NppIO.cpp
@@ -32,7 +32,7 @@
 #include "EncodingMapper.h"
 #include "VerticalFileSwitcher.h"
 #include "functionListPanel.h"
-#include <TCHAR.h>
+#include <tchar.h>
 
 
 BufferID Notepad_plus::doOpen(const TCHAR *fileName, bool isRecursive, bool isReadOnly, int encoding, const TCHAR *backupFileName, time_t fileNameTimestamp)
@@ -1552,4 +1552,4 @@ void Notepad_plus::saveSession(const Session & session)
 void Notepad_plus::saveCurrentSession()
 {
 	::PostMessage(_pPublicInterface->getHSelf(), NPPM_INTERNAL_SAVECURRENTSESSION, 0, 0);
-}
\ No newline at end of file
+}
diff --git a/PowerEditor/src/ScitillaComponent/ScintillaEditView.cpp b/PowerEditor/src/ScitillaComponent/ScintillaEditView.cpp
index e15ac33..0f10413 100644
--- a/PowerEditor/src/ScitillaComponent/ScintillaEditView.cpp
+++ b/PowerEditor/src/ScitillaComponent/ScintillaEditView.cpp
@@ -29,7 +29,7 @@
 #include "precompiledHeaders.h"
 #include "ScintillaEditView.h"
 #include "Parameters.h"
-#include "TCHAR.h"
+#include "tchar.h"
 
 
 // initialize the static variable
@@ -3186,4 +3186,4 @@ bool ScintillaEditView::swapLines(size_t line1, size_t line2)
 	delete[] line2text;
 
 	return true;
-}
\ No newline at end of file
+}
diff --git a/PowerEditor/src/ScitillaComponent/UserDefineDialog.h b/PowerEditor/src/ScitillaComponent/UserDefineDialog.h
index 09fd535..5940be7 100644
--- a/PowerEditor/src/ScitillaComponent/UserDefineDialog.h
+++ b/PowerEditor/src/ScitillaComponent/UserDefineDialog.h
@@ -50,7 +50,7 @@ static int max(int a, int b) {
 };
 #endif //__GNUC__
 #include "tchar.h"
-#include "scilexer.h"
+#include "SciLexer.h"
 #include <map>
 using namespace std;
 class ScintillaEditView;
diff --git a/PowerEditor/src/ScitillaComponent/UserDefineLangReference.h b/PowerEditor/src/ScitillaComponent/UserDefineLangReference.h
index cc92406..696b726 100644
--- a/PowerEditor/src/ScitillaComponent/UserDefineLangReference.h
+++ b/PowerEditor/src/ScitillaComponent/UserDefineLangReference.h
@@ -30,7 +30,7 @@
 #define USER_DEFINE_LANG_REFERENCE_H
 
 #ifndef SCILEXER_H
-#include "scilexer.h"
+#include "SciLexer.h"
 #endif //SCILEXER_H
 
 const int langNameLenMax = 33;
diff --git a/PowerEditor/src/WinControls/AnsiCharPanel/ListView.h b/PowerEditor/src/WinControls/AnsiCharPanel/ListView.h
index 0b7faf3..6cdb0cb 100644
--- a/PowerEditor/src/WinControls/AnsiCharPanel/ListView.h
+++ b/PowerEditor/src/WinControls/AnsiCharPanel/ListView.h
@@ -29,7 +29,7 @@
 #ifndef LISTVIEW_H
 #define LISTVIEW_H
 
-#include "window.h"
+#include "Window.h"
 
 class ListView : public Window
 {
diff --git a/PowerEditor/src/WinControls/ColourPicker/WordStyleDlg.rc b/PowerEditor/src/WinControls/ColourPicker/WordStyleDlg.rc
index 95d8f8b..ced8d15 100644
--- a/PowerEditor/src/WinControls/ColourPicker/WordStyleDlg.rc
+++ b/PowerEditor/src/WinControls/ColourPicker/WordStyleDlg.rc
@@ -27,7 +27,7 @@
 
 
 #include "windows.h"
-#include "wordstyledlgres.h"
+#include "WordStyleDlgRes.h"
 
 #ifndef IDC_STATIC 
 #define IDC_STATIC -1
diff --git a/PowerEditor/src/WinControls/DockingWnd/DockingManager.cpp b/PowerEditor/src/WinControls/DockingWnd/DockingManager.cpp
index f93efb7..082e35b 100644
--- a/PowerEditor/src/WinControls/DockingWnd/DockingManager.cpp
+++ b/PowerEditor/src/WinControls/DockingWnd/DockingManager.cpp
@@ -31,7 +31,7 @@
 #include "DockingSplitter.h"
 #include "DockingCont.h"
 #include "Gripper.h"
-#include "parameters.h"
+#include "Parameters.h"
 
 
 BOOL DockingManager::_isRegistered = FALSE;
diff --git a/PowerEditor/src/WinControls/FindCharsInRange/FindCharsInRange.cpp b/PowerEditor/src/WinControls/FindCharsInRange/FindCharsInRange.cpp
index 7971658..657e73e 100644
--- a/PowerEditor/src/WinControls/FindCharsInRange/FindCharsInRange.cpp
+++ b/PowerEditor/src/WinControls/FindCharsInRange/FindCharsInRange.cpp
@@ -28,7 +28,7 @@
 
 #include "precompiledHeaders.h"
 #include "FindCharsInRange.h"
-#include "FindCharsInRange_rc.h"
+#include "findCharsInRange_rc.h"
 
 BOOL CALLBACK FindCharsInRangeDlg::run_dlgProc(UINT message, WPARAM wParam, LPARAM)
 {
diff --git a/PowerEditor/src/WinControls/FunctionList/functionParser.cpp b/PowerEditor/src/WinControls/FunctionList/functionParser.cpp
index 6c112fd..287cdcc 100644
--- a/PowerEditor/src/WinControls/FunctionList/functionParser.cpp
+++ b/PowerEditor/src/WinControls/FunctionList/functionParser.cpp
@@ -28,7 +28,7 @@
 #include "precompiledHeaders.h"
 #include "ScintillaEditView.h"
 #include "functionParser.h"
-#include "boostregexsearch.h"
+#include "BoostRegexSearch.h"
 
 FunctionParsersManager::~FunctionParsersManager()
 {
@@ -675,4 +675,4 @@ void FunctionMixParser::parse(std::vector<foundInfo> & foundInfos, size_t begin,
 			_funcUnitPaser->funcParse(foundInfos, nonScannedZones[i].first, nonScannedZones[i].second, ppEditView, classStructName);
 		}
 	}
-}
\ No newline at end of file
+}
diff --git a/PowerEditor/src/WinControls/Grid/BabyGrid.cpp b/PowerEditor/src/WinControls/Grid/BabyGrid.cpp
index c5cfb93..c31a14e 100644
--- a/PowerEditor/src/WinControls/Grid/BabyGrid.cpp
+++ b/PowerEditor/src/WinControls/Grid/BabyGrid.cpp
@@ -11,7 +11,7 @@ Modified by Don HO <don.h@free.fr>
 */
 
 #include "precompiledHeaders.h"
-#include "babygrid.h"
+#include "BabyGrid.h"
 #include "Parameters.h"
 
 #define MAX_GRIDS 20
diff --git a/PowerEditor/src/WinControls/Grid/BabyGridWrapper.h b/PowerEditor/src/WinControls/Grid/BabyGridWrapper.h
index 85f2fb9..19e2a9f 100644
--- a/PowerEditor/src/WinControls/Grid/BabyGridWrapper.h
+++ b/PowerEditor/src/WinControls/Grid/BabyGridWrapper.h
@@ -30,7 +30,7 @@
 #define BABYGRIDWRAPPER
 
 #ifndef BABYGRID_H
-#include "babygrid.h"
+#include "BabyGrid.h"
 #endif// BABYGRID_H
 
 class BabyGridWrapper : public Window
diff --git a/PowerEditor/src/WinControls/ProjectPanel/TreeView.h b/PowerEditor/src/WinControls/ProjectPanel/TreeView.h
index 0138fe8..a7c313d 100644
--- a/PowerEditor/src/WinControls/ProjectPanel/TreeView.h
+++ b/PowerEditor/src/WinControls/ProjectPanel/TreeView.h
@@ -28,7 +28,7 @@
 #ifndef TREE_VIEW_H
 #define TREE_VIEW_H
 
-#include "window.h"
+#include "Window.h"
 
 struct TreeStateNode {
 	generic_string _label;
diff --git a/PowerEditor/src/WinControls/ToolBar/ToolBar.cpp b/PowerEditor/src/WinControls/ToolBar/ToolBar.cpp
index 94af92a..f7b991b 100644
--- a/PowerEditor/src/WinControls/ToolBar/ToolBar.cpp
+++ b/PowerEditor/src/WinControls/ToolBar/ToolBar.cpp
@@ -28,7 +28,7 @@
 
 #include "precompiledHeaders.h"
 #include "ToolBar.h"
-#include "Shortcut.h"
+#include "shortcut.h"
 #include "Parameters.h"
 #include "FindReplaceDlg_rc.h"
 
diff --git a/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcherListView.h b/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcherListView.h
index 35b383b..315ee11 100644
--- a/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcherListView.h
+++ b/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcherListView.h
@@ -29,7 +29,7 @@
 #ifndef VERTICALFILESWITCHERLISTVIEW_H
 #define VERTICALFILESWITCHERLISTVIEW_H
 
-#include "window.h"
+#include "Window.h"
 #include "TaskListDlg.h"
 
 #define SORT_DIRECTION_UP     0
-- 
2.2.1