From d054e1270f1990d4402f309366685643d4307d71 Mon Sep 17 00:00:00 2001
From: Markus Heidelberg <markus.heidelberg@web.de>
Date: Wed, 10 Dec 2014 01:29:19 +0100
Subject: [PATCH 11/28] Fix GCC compile errors: extra qualification on member

Error message e.g.:
extra qualification 'ScintillaKeyMap::' on member 'setKeyComboByIndex' [-fpermissive]
---
 PowerEditor/src/Notepad_plus.h                                          | 2 +-
 PowerEditor/src/Notepad_plus_Window.h                                   | 2 +-
 PowerEditor/src/ScitillaComponent/Printer.h                             | 2 +-
 PowerEditor/src/ScitillaComponent/ScintillaEditView.h                   | 2 +-
 PowerEditor/src/WinControls/AnsiCharPanel/ansiCharPanel.h               | 2 +-
 PowerEditor/src/WinControls/ClipboardHistory/clipboardHistoryPanel.h    | 2 +-
 PowerEditor/src/WinControls/ProjectPanel/ProjectPanel.h                 | 2 +-
 PowerEditor/src/WinControls/TabBar/ControlsTab.h                        | 2 +-
 PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcher.h | 2 +-
 PowerEditor/src/WinControls/shortcut/shortcut.h                         | 2 +-
 10 files changed, 10 insertions(+), 10 deletions(-)

diff --git a/PowerEditor/src/Notepad_plus.h b/PowerEditor/src/Notepad_plus.h
index f9ca975..72cda75 100644
--- a/PowerEditor/src/Notepad_plus.h
+++ b/PowerEditor/src/Notepad_plus.h
@@ -604,7 +604,7 @@ private:
 	int getLangFromMenuName(const TCHAR * langName);
 	generic_string getLangFromMenu(const Buffer * buf);
 
-    generic_string Notepad_plus::exts2Filters(generic_string exts) const;
+	generic_string exts2Filters(generic_string exts) const;
 	int setFileOpenSaveDlgFilters(FileDialog & fDlg, int langType = -1);
 	void markSelectedTextInc(bool enable);
 	Style * getStyleFromName(const TCHAR *styleName);
diff --git a/PowerEditor/src/Notepad_plus_Window.h b/PowerEditor/src/Notepad_plus_Window.h
index 782756a..253dffe 100644
--- a/PowerEditor/src/Notepad_plus_Window.h
+++ b/PowerEditor/src/Notepad_plus_Window.h
@@ -85,7 +85,7 @@ public:
         ::DestroyWindow(_hSelf);
     };
 
-	static const TCHAR * Notepad_plus_Window::getClassName() {
+	static const TCHAR * getClassName() {
 		return _className;
 	};
 	static HWND gNppHWND;	//static handle to Notepad++ window, NULL if non-existant
diff --git a/PowerEditor/src/ScitillaComponent/Printer.h b/PowerEditor/src/ScitillaComponent/Printer.h
index b9fae44..91e2fb8 100644
--- a/PowerEditor/src/ScitillaComponent/Printer.h
+++ b/PowerEditor/src/ScitillaComponent/Printer.h
@@ -47,7 +47,7 @@ class Printer
 public :
 	Printer(){};
 	void init(HINSTANCE hInst, HWND hwnd, ScintillaEditView *pSEView, bool showDialog, int startPos, int endPos);
-	size_t Printer::doPrint() {
+	size_t doPrint() {
 		if (!::PrintDlg(&_pdlg))
 				return 0;
 
diff --git a/PowerEditor/src/ScitillaComponent/ScintillaEditView.h b/PowerEditor/src/ScitillaComponent/ScintillaEditView.h
index 0f5781b..1d57c4d 100644
--- a/PowerEditor/src/ScitillaComponent/ScintillaEditView.h
+++ b/PowerEditor/src/ScitillaComponent/ScintillaEditView.h
@@ -585,7 +585,7 @@ public:
 		execute(SCI_INDICATORCLEARRANGE, docStart, docEnd-docStart);
 	};
 
-	static LanguageName ScintillaEditView::langNames[L_EXTERNAL+1];
+	static LanguageName langNames[L_EXTERNAL+1];
 
 	void bufferUpdated(Buffer * buffer, int mask);
 	BufferID getCurrentBufferID() { return _currentBufferID; };
diff --git a/PowerEditor/src/WinControls/AnsiCharPanel/ansiCharPanel.h b/PowerEditor/src/WinControls/AnsiCharPanel/ansiCharPanel.h
index 0d45bfb..f9659d3 100644
--- a/PowerEditor/src/WinControls/AnsiCharPanel/ansiCharPanel.h
+++ b/PowerEditor/src/WinControls/AnsiCharPanel/ansiCharPanel.h
@@ -72,7 +72,7 @@ public:
     };
 	
 protected:
-	virtual BOOL CALLBACK AnsiCharPanel::run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
+	virtual BOOL CALLBACK run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
 
 private:
 	ScintillaEditView **_ppEditView;
diff --git a/PowerEditor/src/WinControls/ClipboardHistory/clipboardHistoryPanel.h b/PowerEditor/src/WinControls/ClipboardHistory/clipboardHistoryPanel.h
index 39d7b2b..b261f49 100644
--- a/PowerEditor/src/WinControls/ClipboardHistory/clipboardHistoryPanel.h
+++ b/PowerEditor/src/WinControls/ClipboardHistory/clipboardHistoryPanel.h
@@ -99,7 +99,7 @@ public:
 	void drawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
 
 protected:
-	virtual BOOL CALLBACK ClipboardHistoryPanel::run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
+	virtual BOOL CALLBACK run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
 
 private:
 	ScintillaEditView **_ppEditView;
diff --git a/PowerEditor/src/WinControls/ProjectPanel/ProjectPanel.h b/PowerEditor/src/WinControls/ProjectPanel/ProjectPanel.h
index 97dcecb..495dc7f 100644
--- a/PowerEditor/src/WinControls/ProjectPanel/ProjectPanel.h
+++ b/PowerEditor/src/WinControls/ProjectPanel/ProjectPanel.h
@@ -134,7 +134,7 @@ protected:
 	void setWorkSpaceDirty(bool isDirty);
 	void popupMenuCmd(int cmdID);
 	POINT getMenuDisplyPoint(int iButton);
-	virtual BOOL CALLBACK ProjectPanel::run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
+	virtual BOOL CALLBACK run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
 	bool buildTreeFrom(TiXmlNode *projectRoot, HTREEITEM hParentItem);
 	void notified(LPNMHDR notification);
 	void showContextMenu(int x, int y);
diff --git a/PowerEditor/src/WinControls/TabBar/ControlsTab.h b/PowerEditor/src/WinControls/TabBar/ControlsTab.h
index ff6d9d0..925f84a 100644
--- a/PowerEditor/src/WinControls/TabBar/ControlsTab.h
+++ b/PowerEditor/src/WinControls/TabBar/ControlsTab.h
@@ -53,7 +53,7 @@ public :
 		_isVertical = isVertical;
 		TabBar::init(hInst, hwnd, false, isTraditional, isMultiLine);
 	};
-	void ControlsTab::createTabs(WindowVector & winVector);
+	void createTabs(WindowVector & winVector);
 
 	void destroy() {
 		TabBar::destroy();
diff --git a/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcher.h b/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcher.h
index e8cbe3e..5fb08eb 100644
--- a/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcher.h
+++ b/PowerEditor/src/WinControls/VerticalFileSwitcher/VerticalFileSwitcher.h
@@ -104,7 +104,7 @@ public:
     };
 
 protected:
-	virtual BOOL CALLBACK VerticalFileSwitcher::run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
+	virtual BOOL CALLBACK run_dlgProc(UINT message, WPARAM wParam, LPARAM lParam);
 
 private:
 	VerticalFileSwitcherListView _fileListView;
diff --git a/PowerEditor/src/WinControls/shortcut/shortcut.h b/PowerEditor/src/WinControls/shortcut/shortcut.h
index 91f6bb2..d396be7 100644
--- a/PowerEditor/src/WinControls/shortcut/shortcut.h
+++ b/PowerEditor/src/WinControls/shortcut/shortcut.h
@@ -215,7 +215,7 @@ public:
 	};
 
 	KeyCombo getKeyComboByIndex(int index) const;
-	void ScintillaKeyMap::setKeyComboByIndex(int index, KeyCombo combo);
+	void setKeyComboByIndex(int index, KeyCombo combo);
 	void removeKeyComboByIndex(int index);
 	void clearDups() {
 		if (size > 1)
-- 
2.2.1